<?php 
/*
    QPanel, Hosting Panel

    Copyright (C) 2000-2009     Kloxo - LxLabs
    Copyright (C) 2009-2010     Kloxo - LxCenter
    Copyright (C) 2011          QPanel - Quijost

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

if(posix_getuid() != 0) 
{
    die('You need to be root for run this script.' . "\n"); 
}

require_once 'utils.php';

$status = True;
$pass = (isset($argv[1])) ? $argv[1] : '';

echo 'Stopping MySQL ...';
system('service mysqld stop 2> error.log < /dev/null', $status);
showStatus($status, strlen('Stopping MySQL ...'));

# [FIXME] Note: Ubuntu with upstart will need something like "start mysql".
echo 'Start MySQL with skip grant tables ...';
system('su mysql -c "/usr/libexec/mysqld --skip-grant-tables" >/dev/null 2>&1 &', $status);
showStatus($status, strlen('Start MySQL with skip grant tables ...'));

# [FIXME] Note: Ubuntu use /usr/bin/mysqld_safe --user=mysql --skip-grant-tables
echo 'Using MySQL to flush privileges and reset password ...' . PHP_EOL;
system("echo \"UPDATE user SET password = Password('$pass') WHERE User = 'root'\" | mysql -u root mysql > error.log < /dev/null", $status);
showStatus($status, strlen('Using MySQL to flush privileges and reset password ...'));
$attempts = 1;

while($status)
{
    echo 'MySQL could not connect, will sleep and try again on 3 seconds.' . PHP_EOL;
    sleep(3);
    system("echo \"UPDATE user SET Password = PASSWORD('$pass') WHERE User = 'root'\" | mysql -u root mysql > error.log < /dev/null", $status);
    showStatus($status, strlen('MySQL could not connect, will sleep and try again on 3 seconds.'));
    $attempts++;
    
    if($attempts > 5)
    {
        die('Giving up with 5 attempts. Something is wrong with MySQL or it is not started yet.' . PHP_EOL);
        break;
    }
}

echo 'Password reset succesfully. Now killing MySQL softly' . PHP_EOL;
system('killall mysqld > error.log < /dev/null', $status);
showStatus($status, strlen('Password reset succesfully. Now killing MySQL softly'));

echo 'Restarting the actual MySQL service' . "\n";
system('service mysqld restart > error.log < /dev/null', $status);
showStatus($status, strlen('Restarting the actual MySQL service'));

echo 'Password successfully reset to "' . $pass . '"' . "\n";